<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from transform.texi on 28 April 1999 -->

<TITLE>The TRANSFORM Library - Introduction</TITLE>
<link href="transform_2.html" rel=Next>
<link href="transform_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the first, previous, <A HREF="transform_2.html">next</A>, <A HREF="transform_8.html">last</A> section, <A HREF="transform_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC1" HREF="transform_toc.html#TOC1">Introduction</A></H1>

<P>
This document describes the loop transformation library for the SUIF
compiler system.
The loop transformation library provides routines to perform
unimodular loop transformations and tiling.

</P>
<P>
Unimodular transformations include a broad range of standard
loop transformations, including loop interchange, reversal, skewing
and wavefronting. 
These transformations are useful in parallelization or improving the
efficiency of the memory hierarchy.

</P>
<P>
The tiling transformation is also known as 
strip-mine-and-interchange and unroll-and-jam.  It is useful for
improving locality, and for implementing coarse-grain parallelism.

</P>
<P>
This library implements the mechanism for carrying out the
transformations only.  
The policy that determines the legality and desirability of these
transformations must be performed elsewhere.
In the current SUIF compiler system, the <TT>`skweel'</TT> pass decides
when to apply unimodular transforms and tiling to optimize the
loop-level parallelism and locality of the program.

</P>
<P>
The SUIF code manipulation is in the files <TT>`lptrans.h'</TT> and 
<TT>`lptrans.cc'</TT>.  
The code to calculates the loop bound expressions is in the files 
<TT>`bexpr.h'</TT> and <TT>`bexpr.h'</TT>.

</P>
<P><HR><P>
<p>Go to the first, previous, <A HREF="transform_2.html">next</A>, <A HREF="transform_8.html">last</A> section, <A HREF="transform_toc.html">table of contents</A>.
</BODY>
</HTML>
